//Quick and dirty hack to show the rtl8181 gpio works.
//Tells you if the reset button currently is released.

//(c) 2004, Jeroen Domburg (Sprite_TM)
//This software is released under the GPL.

#include <fcntl.h>
#include <sys/types.h>
#include <unistd.h>


int main() {
    unsigned long b[3];
    int f;
    
    f=open("/dev/gpio",O_RDWR);

    //Make the reset pin an input
    lseek(f,4,SEEK_SET);
    read(f,b,4);
    b[0]=b[0]&(0xffffffff-0x400);
    lseek(f,4,SEEK_SET);
    write(f,b,4);

    //Output a zero to the reset gpio pin.
    //No idea if that's really neccesary btw :)
    lseek(f,8,SEEK_SET);
    read(f,b,4);
    b[0]=b[0]&(0xffffffff-0x400);
    lseek(f,0,SEEK_SET);
    write(f,b,4);
    
    //Read the input of the pins.
    lseek(f,0,SEEK_SET);
    read(f,b,12);
    //Reset-button pressed?
    if (b[0] & 0x400) printf("Reset-button is released.\n"); else printf("Reset-button is pressed.\n");
    close(f);
    
}
